#include<stdio.h>
#include<stdlib.h>
#include"pgm.h"

void tree(unsigned char *image, int width, unsigned char ***data);
void quad(int width, int level, unsigned char **tree);

main(int argc, char *argv[])
{
  unsigned char *image, **data;
  int width, height, max, size;

  max=read_pgm(argv[1], &image, &width, &height);

  tree(image, width, &data);

  write_pgm("tree3.pgm", data[3], width, height, max);
  write_pgm("tree2.pgm", data[2], width/2, height/2, max);
  write_pgm("tree1.pgm", data[1], width/4, height/4, max);
  write_pgm("tree0.pgm", data[0], width/8, height/8, max);

}

void tree(unsigned char *image, int width, unsigned char ***data)
{
  int levels, level_size, max_size;
  int i;

  max_size=width*width;

  levels=4;
  *data = (unsigned char **) malloc(levels*sizeof(unsigned char *));

  level_size = max_size;
  for (i=levels-1; i>=0; i--)
  {

    (*data)[i] = (unsigned char *) 
			malloc(level_size * sizeof(unsigned char));
    level_size=level_size/4;
  }

  memcpy((*data)[levels-1], image, max_size);

  quad(width, levels-2, *data);

}

void quad(int width, int level, unsigned char **data)
{
  int x, y;

  for (y=0; y<width; y+=2)
    for (x=0; x<width; x+=2)
      data[level][y/2*width/2+x/2] = (data[level+1][y*width+x] +
				      data[level+1][y*width+x+1] +
				      data[level+1][(y+1)*width+x] +
				      data[level+1][(y+1)*width+x+1])/4;
  if (level > 0)
    quad(width/2, level-1, data);
}
