#include<stdio.h>
#include<stdlib.h>
#include "pgm.h"
#include "edges.h"
#include "contrast.h"
#include "test.h"

void norm_char(unsigned char *to, unsigned char *from, int size);

main(int argc, char *argv[])
{
  int i, j;
  int level_size[LEVELS];

  unsigned char *image;	/* for read pgm */
  int width, height, max;
  int size;
  int elsize, c_rad;

  unsigned char *edge_map[ORIENTATIONS]; /* for edges */
  unsigned char *inten_map;

  unsigned char *edge_tree[ORIENTATIONS][LEVELS]; /* for tree */
  unsigned char *inten_tree[LEVELS];

  double *dbl_map[LEVELS];     /* for contrast */
  unsigned char *edge_data[LEVELS][ORIENTATIONS];
  unsigned char *c_map[LEVELS];

  char f_name[20];

  c_rad=2;
  if (argc==3)
  {
    sscanf(argv[2], "%d", &elsize);
    c_rad=elsize/8;
    if (elsize%8) c_rad++;
  }

  /* read pgm file */
  max = read_pgm(argv[1], &image, &width, &height);
  size=width*height;

  /* find edges */
  Edges(width, height, size, edge_map, image);
  
  inten_map = (unsigned char *) malloc(size);
  norm_char(inten_map, image, size);

  printf("Edges\n");

  level_size[LEVELS-1]=width;
  for (i=LEVELS-2; i>=0; i--)
    level_size[i]=level_size[i+1]/2;

  /* make trees */
  tree(inten_map, inten_tree, level_size);
  for (i=0; i<ORIENTATIONS; i++)
    tree(edge_map[i], edge_tree[i], level_size);

  printf("tree\n");

  /* find contrast for each level of resolution */
  for (i=0; i<LEVELS; i++)
    for (j=0; j<ORIENTATIONS; j++)
      edge_data[i][j]=edge_tree[j][i];

  for (i=0; i<LEVELS; i++);
  { i=1;
    contrast(inten_tree[i], edge_data[i], level_size[i], &(dbl_map[i]),
		c_rad);
    printf("contrast level %d\n", i);

  /* convert double map to chars for saving */
    c_map[i] = (unsigned char *) malloc(level_size[i]*level_size[i]);
    d_to_c(dbl_map[i], c_map[i], level_size[i]*level_size[i]);

  /* write results to pgm files */
    strncpy(f_name, argv[1], strlen(argv[1])-3);
    f_name[strlen(argv[1])-3]=0;
    sprintf(f_name, "%scon.pgm", f_name);
    write_pgm(f_name, c_map[i], level_size[i], level_size[i], max);
  }

}

void norm_char(unsigned char *to, unsigned char *from, int size)
{
  int i, max=0; 
  double factor;

  for(i=0; i<size; i++)
    if (from[i]>max) max=from[i];

  factor=255.0/max;
  for(i=0; i<size; i++)
    to[i]=from[i]*max;
}
