#include<stdio.h>
#include<stdlib.h>
#include "pgm.h"
#include "edges.h"
#include "contrast.h"
#include "test.h"

void norm_char(unsigned char *to, unsigned char *from, int size);

main(int argc, char *argv[])
{
  int i, j;
  int level_size[LEVELS];

  unsigned char *image;	/* for read pgm */
  int width, height, max;
  int size;
  int elsize, c_rad;

  unsigned char *edge_map[ORIENTATIONS]; /* for edges */
  unsigned char *inten_map;

  double *dbl_map;     /* for contrast */
  unsigned char *c_map;

  char f_name[20];


  /* read pgm file */
  max = read_pgm(argv[1], &image, &width, &height);
  size=width*height;


  /* allocate memory for intensity map */
  inten_map = (unsigned char *) malloc(size);
  c_map = (unsigned char *) malloc(size);


  /* set edge and intensity maps */
  Edges(width, height, size, edge_map, image);
  norm_char(inten_map, image, size);


  /* find contrast for each gaussian radius */
  for (i=0; i<5; i++);
  { 
    c_rad=16;
    contrast(inten_map, edge_map, width, &dbl_map, c_rad);
    printf("radius %d\n", c_rad);

  /* convert double map to chars for saving */
    d_to_c(dbl_map, c_map, size);
    printf("double map\n");


  /* write results to pgm files */
    strncpy(f_name, argv[1], strlen(argv[1])-3);
    f_name[strlen(argv[1])-3]=0;
    sprintf(f_name, "%scon.%d.pgm", f_name, c_rad);
    printf("file name = %s\n", f_name);

    write_pgm(f_name, c_map, width, height, max);
    printf("write pgm\n");
  }

}

void norm_char(unsigned char *to, unsigned char *from, int size)
{
  int i, max=0; 
  double factor;

  for(i=0; i<size; i++)
    if (from[i]>max) max=from[i];

  factor=255.0/max;
  for(i=0; i<size; i++)
    to[i]=from[i]*max;
}
