#include<stdio.h>
#include<stdlib.h>
#include "pgm.h" 
#include "test.h"
#include "tree.h"

/*
main(int argc, char *argv[])
{
  unsigned char *image, **data;
  int width, height, max, size;

  max=read_pgm(argv[1], &image, &width, &height);

  tree(image, width, &data);

  write_pgm("tree3.pgm", data[3], width, height, max);
  write_pgm("tree2.pgm", data[2], width/2, height/2, max);
  write_pgm("tree1.pgm", data[1], width/4, height/4, max);
  write_pgm("tree0.pgm", data[0], width/8, height/8, max);

}
*/
void tree(int *image, int **data, int *level_size, int **weights)
{
  int levels, max_size;
  int i, j, width;
  FILE *out;

  max_size=level_size[LEVELS-1]*level_size[LEVELS-1];

  for (i=LEVELS-1; i>0; i--)
    data[i] = (int *) calloc(level_size[i]*level_size[i], sizeof(int));

  memcpy(data[LEVELS-1], image, max_size*sizeof(int));

  quad(level_size[LEVELS-1], LEVELS-2, data, weights);

}

void quad(int width, int level, int **data, int **w)
{
  int x, y;
  int sum, count;

  for (y=0; y<width; y+=2)
    for (x=0; x<width; x+=2)
    {
      if (data[level+1][y*width+x] + data[level+1][y*width+(x+1)] +
          data[level+1][(y+1)*width+x] + data[level+1][(y+1)*width+(x+1)]
	  == -4)
	data[level][y/2*width/2+x/2]=-1;

      else
      {
	sum=0;
	count=0;
	if (data[level+1][y*width+x]!=-1)
	{
	  sum+=data[level+1][y*width+x]*w[level+1][y*width+x];
	  count+=w[level+1][y*width+x];
	}
	if (data[level+1][y*width+(x+1)]!=-1)
	{
          sum+=data[level+1][y*width+(x+1)]*w[level+1][y*width+(x+1)];
          count+=w[level+1][y*width+(x+1)];
	}
	if (data[level+1][(y+1)*width+x]!=-1)
	{
          sum+=data[level+1][(y+1)*width+x]*w[level+1][(y+1)*width+x];
          count+=w[level+1][(y+1)*width+x];
	}
	if (data[level+1][(y+1)*width+(x+1)]!=-1)
	{
          sum+=data[level+1][(y+1)*width+x+1]*w[level+1][(y+1)*width+x+1];
          count+=w[level+1][(y+1)*width+(x+1)];
	}

	if (count==0) data[level][y/2*width/2+x/2]=0;
	else data[level][y/2*width/2+x/2]=((double)sum/(double)count+0.5);
      }
    }

  if (level > 1)
    quad(width/2, level-1, data, w);
}
